
MANUFACTURER 179,
DEVICE_TYPE 1,
DEVICE_REVISION 1,
DD_REVISION 1


#define DEVICE_TITLE				"HAWK LEVEL DEVICES"
#define DEFAULT_MANUFACTURER_ID			179
#define DEFAULT_phys_ident_number		0    //default value of PB parameter "phys_ident_number"
#define DEFAULT_VALUE_phys_device_id		"Level           "
#define DEFAULT_VALUE_phys_software_rev		"xxxx"	
#define DEFAULT_VALUE_phys_hardware_rev		"XXXXX"


/**************************************************************************************************/
/*    Physical Block								  */
/**************************************************************************************************/

// defines used inside the following included file
#define DEVICE_TYPE 				"SultanAW Level"			// "|de|Fllstand" "|fr|Niveau" "|sp|Nivel" "|sp|Livello di riempimento"
#define OPT_PHYS_IDENT_NUMBER_MANUFACTURER 						/* our own ident number */
#define PHYSICAL_BLOCK_PARENT_CLASS 		1, [phys_blk_parent_class_TRANSMITTER]	// PB.BLOCK_OBJECT.PARENT_CLASS
#define	CHECK_DEVICE_TYPE 			"SultanAW Level"         		// check the value of PB.DEVICE_ID
#define CHECK_PROFILE_REV 			0x0300  				// PA-Profil 3.01 for BLOCK_OBJECT
#define DEFAULT_VALUE_phys_diagnosis_mask	0x00110010 				// fill your default value

// standard input for physical block, provided by Siemens SIMATIC PDM
#include "SIPASTPB_Hawk.inc"

// some general definition, e.g. unit codes
#include "SIPAST_Macros_300.inc"

// PDM specific stuff for identification
#include "SIPAST.inc"


#define	FLOAT_MIN	-3.4E+38
#define	FLOAT_MAX	 3.4E+38


/* Defines for Y-t-Diagram -------------------------------------- */
#define YT1_LABEL	[func_out_value1]
#define YT1_VALUE	func1_AI_out_value
#define	YT1_LRV		func1_AI_out_lower_range_value
#define YT1_URV		func1_AI_out_upper_range_value

#define YT2_LABEL	[func_out_value2]
#define YT2_VALUE	func2_AI_out_value
#define	YT2_LRV		func2_AI_out_lower_range_value
#define YT2_URV		func2_AI_out_upper_range_value

#define YT3_LABEL	[func_out_value3]
#define YT3_VALUE	func3_AI_out_value
#define	YT3_LRV		func3_AI_out_lower_range_value
#define YT3_URV		func3_AI_out_upper_range_value

#define YT4_LABEL	[func_out_value4]
#define YT4_VALUE	func4_AI_out_value
#define	YT4_LRV		func4_AI_out_lower_range_value
#define YT4_URV		func4_AI_out_upper_range_value

// use the PDM specific y-t-diagram for representation
#include "SI_YT.inc"

 
//you must define one of the follow (sub class  of level)
//#define _TRANS1_LEVEL_HYDRO
//#define _TRANS1_LEVEL_ECHO
//#define _TRANS1_LEVEL_CAPACITIVE 

// use TB #1 in your EDD
#include "Trans1_Level_Echo_Hawk.inc"



//these parameters will be read from device, regarding to TB #1

#define TRANS1_LEVEL_LOAD_TO_PC			\
		trans1_blk_profile_rev,		\
		trans1_st_rev,			\
		trans1_tag_desc,		\
		trans1_strategy,		\
		trans1_alert_key,		\
		trans1_target_mode,		\
		trans1_permitted_mode,		\
		trans1_normal_mode              \
		trans1_primary_value_value	\
		trans1_primary_value_unit	\
		trans1_level			\
		trans1_level_unit		\
		trans1_sensor_value		\
		trans1_sensor_unit		\
		trans1_secondary_value_1_value	\
		trans1_secondary_value_1_unit	\
		trans1_secondary_value_2_value	\
		trans1_secondary_value_2_unit	\
		trans1_sensor_offset		\
		trans1_caltype      		\
		trans1_cal_point_lo     	\
	        trans1_cal_point_hi     	\
		trans1_level_lo         	\
		trans1_level_hi         	\
		trans1_level_offset     	\
		trans1_lin_type         	\
		trans1_lin_diameter     	\
		trans1_lin_volume       	\
		trans1_sensor_high_limit	\
		trans1_sensor_low_limit 	\
		trans1_max_sensor_value 	\
		trans1_min_sensor_value 	\
		trans1_temperature       	\
		trans1_temperature_unit  	\
		trans1_max_temperature   	\
		trans1_min_temperature   	\
		trans1_index             	\
		trans1_tab_x_y_value.X    	\
		trans1_tab_x_y_value.Y		\
		trans1_tab_min_number   	\
		trans1_tab_max_number   	\
		trans1_tab_op_code      	\
		trans1_tab_status       	\
		trans1_tab_actual_number	\
		trans1_clarity	     	  	\
		trans1_floc     		\
		trans1_failsafe 		\
		trans1_failtime  		\
		trans1_app_type 		\
		trans1_fill_rate 		\
		trans1_empty_rate		\
		trans1_filldamp 		\
		trans1_emtydamp 		\
		trans1_gain   			\
		trans1_gain_step3		\
		trans1_distance_step3		\
		trans1_threshold		\
		trans1_blanking			\
		trans1_empty			\
		trans1_tempdiv			\
		trans1_txdist_offset		\
		trans1_comp_factor		\
		trans1_map_dist			\
		trans1_map_used
		
		
		// please add here further parameter

/*
 * these parameters will be written to device, regarding to TB #1
 */
#define TRANS1_LEVEL_LOAD_TO_DEVICE \
		trans1_primary_value_unit,\
		trans1_temperature_unit
		// please add here further parameter


/*************************************************************************************************/
/*    Function Block                                                   				  */
/*************************************************************************************************/

// FB AI 1

// you can make user specific defines for the following
#define DEFAULT_VALUE_func1_upper_range_value			10.0
#define DEFAULT_VALUE_func1_lower_range_value			0.0
#define DEFAULT_VALUE_func1_AI_hi_hi_lim FLOAT_MAX
#define DEFAULT_VALUE_func1_AI_hi_lim FLOAT_MAX
#define DEFAULT_VALUE_func1_AI_lo_lim FLOAT_MIN
#define DEFAULT_VALUE_func1_AI_lo_lo_lim FLOAT_MIN
#define DEFAULT_VALUE_func1_AI_out_unit				1342
#define FUNC1_UNIT_LIST	UNIT_LIST
#define FUNC1_DEFAULT_UNIT					1010
#define MAX_VALUE_func1_AI_pv_ftime				300
#define DEFAULT_VALUE_func1_AI_pv_ftime				1

#include "SIPASTAI1_Hawk.inc"


// FB AI 2

// you can make user specific defines for the following
#define DEFAULT_VALUE_func2_upper_range_value	10.0
#define DEFAULT_VALUE_func2_lower_range_value	0.0
#define DEFAULT_VALUE_func2_AI_hi_hi_lim FLOAT_MAX
#define DEFAULT_VALUE_func2_AI_hi_lim FLOAT_MAX
#define DEFAULT_VALUE_func2_AI_lo_lim FLOAT_MIN
#define DEFAULT_VALUE_func2_AI_lo_lo_lim FLOAT_MIN
#define DEFAULT_VALUE_func2_AI_out_unit	1342
#define FUNC2_UNIT_LIST	UNIT_LIST
#define FUNC2_DEFAULT_UNIT		1010
#define MAX_VALUE_func2_AI_pv_ftime		300
#define DEFAULT_VALUE_func2_AI_pv_ftime		1

#include "SIPASTAI2_Hawk.inc"

// FB AI 3
// you can make user specific defines for the following
#define DEFAULT_VALUE_func3_upper_range_value	10.0
#define DEFAULT_VALUE_func3_lower_range_value	0.0
#define DEFAULT_VALUE_func3_AI_hi_hi_lim FLOAT_MAX
#define DEFAULT_VALUE_func3_AI_hi_lim FLOAT_MAX
#define DEFAULT_VALUE_func3_AI_lo_lim FLOAT_MIN
#define DEFAULT_VALUE_func3_AI_lo_lo_lim FLOAT_MIN
#define DEFAULT_VALUE_func3_AI_out_unit	1342
#define FUNC3_UNIT_LIST	UNIT_LIST
#define FUNC3_DEFAULT_UNIT		1010
#define MAX_VALUE_func3_AI_pv_ftime		300
#define DEFAULT_VALUE_func3_AI_pv_ftime		1

#include "SIPASTAI3_Hawk.inc"

// FB AI 4
// you can make user specific defines for the following
#define DEFAULT_VALUE_func4_upper_range_value	10.0
#define DEFAULT_VALUE_func4_lower_range_value	0.0
#define DEFAULT_VALUE_func4_AI_hi_hi_lim FLOAT_MAX
#define DEFAULT_VALUE_func4_AI_hi_lim FLOAT_MAX
#define DEFAULT_VALUE_func4_AI_lo_lim FLOAT_MIN
#define DEFAULT_VALUE_func4_AI_lo_lo_lim FLOAT_MIN
#define DEFAULT_VALUE_func4_AI_out_unit	1342
#define FUNC4_UNIT_LIST	UNIT_LIST
#define FUNC4_DEFAULT_UNIT		1010
#define MAX_VALUE_func4_AI_pv_ftime		300
#define DEFAULT_VALUE_func4_AI_pv_ftime		1

#include "SIPASTAI4_Hawk.inc"


#include "SIPAST_CommError.inc"
#include "SIPAST_CommonDlgs.inc"

#include "SI_DevM.inc"
#include "SI_HlpM.inc"
#include "SI_FileM.inc"
#include "SI_ViewM_Hawk.inc"
#include "SI_OptM.inc"

/***** global definition **************/
//#include "SultanAW_M.inc"  

/***** Variables and Commands *********/
#include "SultanAW_VC.inc"
//#include "Trans1_Level_Hawk_Factory.inc"

/***** Menue **************************/
#include "SultanAW_M.inc" 

/***** Tables *************************/
#include "SultanAW_T.inc" 


// you can add user specific refernces to dialogs and windows
#define EXTRA_ITEMS_DEVICE_MENU_SPECIALIST_COMMON_DLGS \
        Menu_simulation

/* you can define further refernces to dialogs and windows
#define EXTRA_ITEMS_DEVICE_MENU_SPECIALIST	\
		OnlineDialog_xxxx
*/
		
		
		/*

#define		LEVEL_HYDRO		\
((trans1_blk_parent_class == 4) && (trans1_blk_class == 1))

#define		LEVEL_ECHO		\
((trans1_blk_parent_class == 4) && (trans1_blk_class == 2))


#define		VALID_LEVEL_HYDRO	\
IF (LEVEL_HYDRO)			\
{					\
	TRUE;				\
}					\
ELSE {					\
	FALSE;				\
}

#define		VALID_LEVEL_ECHO	\
IF (LEVEL_ECHO)				\
{					\
	TRUE;				\
}					\
ELSE {					\
	FALSE;				\
}
*/
// --- Communication ----------------------------------------------------------

MENU download_variables
{
	LABEL		[menu_load_to_PC];
	ITEMS
	{
		PHYS_LOAD_TO_PC,  // from include
		TRANS1_LEVEL_LOAD_TO_PC,
		FUNC1_LOAD_TO_PC,
		FUNC2_LOAD_TO_PC,
		FUNC3_LOAD_TO_PC,
		FUNC4_LOAD_TO_PC
	}
}



MENU upload_variables
{
	LABEL		[menu_load_to_device];
	ITEMS
	{
		PHYS_LOAD_TO_DEVICE,   // from include
		TRANS1_LEVEL_LOAD_TO_DEVICE,
		FUNC1_LOAD_TO_DEVICE,
		FUNC2_LOAD_TO_DEVICE,
		FUNC3_LOAD_TO_PC,
		FUNC4_LOAD_TO_PC
	}
}

/*
 * this method is a dummy, because PDM has a specific behaviour setting values
 * it is not necessary in Workbench or EDDview DTM, but must also be defined, 
 * because referenced in the MENUs
 */
#ifdef _EDDY_
METHOD method_set
{
	LABEL		[transferWrite];
	HELP		[transferWrite_help];
	CLASS		INPUT;
  ACCESS  ONLINE;
	DEFINITION
	{
	}
}
#endif
